EAPI EAPI_WEAK const Efl_Event_Description _EFL_CANVAS_WL_EVENT_TOPLEVEL_ADDED =
   EFL_EVENT_DESCRIPTION("toplevel,added");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_CANVAS_WL_EVENT_CHILD_ADDED =
   EFL_EVENT_DESCRIPTION("child,added");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_CANVAS_WL_EVENT_POPUP_ADDED =
   EFL_EVENT_DESCRIPTION("popup,added");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_CANVAS_WL_EVENT_SEAT_ADDED =
   EFL_EVENT_DESCRIPTION("seat,added");

Efl_Exe *_efl_canvas_wl_run(Eo *obj, Comp *pd, const char *cmd);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_canvas_wl_run, Efl_Exe *, NULL, EFL_FUNC_CALL(cmd), const char *cmd);

void _efl_canvas_wl_exec_flags_set(Eo *obj, Comp *pd, Efl_Exe_Flags flags);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_exec_flags_set, EFL_FUNC_CALL(flags), Efl_Exe_Flags flags);

Efl_Exe_Flags _efl_canvas_wl_exec_flags_get(const Eo *obj, Comp *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_canvas_wl_exec_flags_get, Efl_Exe_Flags, 0);

void _efl_canvas_wl_allowed_pid_add(Eo *obj, Comp *pd, int pid);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_allowed_pid_add, EFL_FUNC_CALL(pid), int pid);

void _efl_canvas_wl_allowed_pid_del(Eo *obj, Comp *pd, int pid);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_allowed_pid_del, EFL_FUNC_CALL(pid), int pid);

Efl_Canvas_Wl_Surface *_efl_canvas_wl_surface_next(Eo *obj, Comp *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_canvas_wl_surface_next, Efl_Canvas_Wl_Surface *, NULL);

Efl_Canvas_Wl_Surface *_efl_canvas_wl_surface_prev(Eo *obj, Comp *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_canvas_wl_surface_prev, Efl_Canvas_Wl_Surface *, NULL);

Eina_Bool _efl_canvas_wl_active_surface_set(Eo *obj, Comp *pd, Efl_Canvas_Wl_Surface *surface);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_canvas_wl_active_surface_set, Eina_Bool, 0, EFL_FUNC_CALL(surface), Efl_Canvas_Wl_Surface *surface);

Efl_Canvas_Wl_Surface *_efl_canvas_wl_active_surface_get(const Eo *obj, Comp *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_canvas_wl_active_surface_get, Efl_Canvas_Wl_Surface *, NULL);

void _efl_canvas_wl_aspect_propagate_set(Eo *obj, Comp *pd, Eina_Bool set);


static Eina_Error
__eolian_efl_canvas_wl_aspect_propagate_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_wl_aspect_propagate_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_aspect_propagate_set, EFL_FUNC_CALL(set), Eina_Bool set);

Eina_Bool _efl_canvas_wl_aspect_propagate_get(const Eo *obj, Comp *pd);


static Eina_Value
__eolian_efl_canvas_wl_aspect_propagate_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_wl_aspect_propagate_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_canvas_wl_aspect_propagate_get, Eina_Bool, 0);

void _efl_canvas_wl_minmax_propagate_set(Eo *obj, Comp *pd, Eina_Bool set);


static Eina_Error
__eolian_efl_canvas_wl_minmax_propagate_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_wl_minmax_propagate_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_minmax_propagate_set, EFL_FUNC_CALL(set), Eina_Bool set);

Eina_Bool _efl_canvas_wl_minmax_propagate_get(const Eo *obj, Comp *pd);


static Eina_Value
__eolian_efl_canvas_wl_minmax_propagate_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_wl_minmax_propagate_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_canvas_wl_minmax_propagate_get, Eina_Bool, 0);

void _efl_canvas_wl_rotation_set(Eo *obj, Comp *pd, Efl_Canvas_Wl_Rotation rotation, Eina_Bool rtl);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_rotation_set, EFL_FUNC_CALL(rotation, rtl), Efl_Canvas_Wl_Rotation rotation, Eina_Bool rtl);

void _efl_canvas_wl_rotation_get(const Eo *obj, Comp *pd, Efl_Canvas_Wl_Rotation *rotation, Eina_Bool *rtl);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_canvas_wl_rotation_get, EFL_FUNC_CALL(rotation, rtl), Efl_Canvas_Wl_Rotation *rotation, Eina_Bool *rtl);

Efl_Canvas_Wl_Wl_Global *_efl_canvas_wl_global_add(Eo *obj, Comp *pd, const Efl_Canvas_Wl_Wl_Interface *interface, unsigned int version, Efl_Canvas_Wl_Wl_Interface_Data *data, Efl_Canvas_Wl_Wl_Interface_Bind_Cb *bind_cb);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_canvas_wl_global_add, Efl_Canvas_Wl_Wl_Global *, NULL, EFL_FUNC_CALL(interface, version, data, bind_cb), const Efl_Canvas_Wl_Wl_Interface *interface, unsigned int version, Efl_Canvas_Wl_Wl_Interface_Data *data, Efl_Canvas_Wl_Wl_Interface_Bind_Cb *bind_cb);

void _efl_canvas_wl_seat_keymap_set(Eo *obj, Comp *pd, Efl_Input_Device *seat, Efl_Canvas_Wl_Xkb_State *state, const char *keymap_str, Efl_Canvas_Wl_Wl_Array *key_array);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_seat_keymap_set, EFL_FUNC_CALL(seat, state, keymap_str, key_array), Efl_Input_Device *seat, Efl_Canvas_Wl_Xkb_State *state, const char *keymap_str, Efl_Canvas_Wl_Wl_Array *key_array);

void _efl_canvas_wl_seat_key_repeat_set(Eo *obj, Comp *pd, Efl_Input_Device *seat, int repeat_rate, int repeat_delay);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_wl_seat_key_repeat_set, EFL_FUNC_CALL(seat, repeat_rate, repeat_delay), Efl_Input_Device *seat, int repeat_rate, int repeat_delay);

Efl_Object *_efl_canvas_wl_efl_object_constructor(Eo *obj, Comp *pd);


void _efl_canvas_wl_efl_gfx_entity_visible_set(Eo *obj, Comp *pd, Eina_Bool v);


void _efl_canvas_wl_efl_gfx_entity_size_set(Eo *obj, Comp *pd, Eina_Size2D size);


void _efl_canvas_wl_efl_gfx_entity_position_set(Eo *obj, Comp *pd, Eina_Position2D pos);


void _efl_canvas_wl_efl_gfx_entity_scale_set(Eo *obj, Comp *pd, double scale);


double _efl_canvas_wl_efl_gfx_entity_scale_get(const Eo *obj, Comp *pd);


static Eina_Bool
_efl_canvas_wl_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_WL_EXTRA_OPS
#define EFL_CANVAS_WL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_run, _efl_canvas_wl_run),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_exec_flags_set, _efl_canvas_wl_exec_flags_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_exec_flags_get, _efl_canvas_wl_exec_flags_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_allowed_pid_add, _efl_canvas_wl_allowed_pid_add),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_allowed_pid_del, _efl_canvas_wl_allowed_pid_del),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_surface_next, _efl_canvas_wl_surface_next),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_surface_prev, _efl_canvas_wl_surface_prev),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_active_surface_set, _efl_canvas_wl_active_surface_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_active_surface_get, _efl_canvas_wl_active_surface_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_aspect_propagate_set, _efl_canvas_wl_aspect_propagate_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_aspect_propagate_get, _efl_canvas_wl_aspect_propagate_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_minmax_propagate_set, _efl_canvas_wl_minmax_propagate_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_minmax_propagate_get, _efl_canvas_wl_minmax_propagate_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_rotation_set, _efl_canvas_wl_rotation_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_rotation_get, _efl_canvas_wl_rotation_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_global_add, _efl_canvas_wl_global_add),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_seat_keymap_set, _efl_canvas_wl_seat_keymap_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_wl_seat_key_repeat_set, _efl_canvas_wl_seat_key_repeat_set),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_canvas_wl_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, _efl_canvas_wl_efl_gfx_entity_visible_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, _efl_canvas_wl_efl_gfx_entity_size_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, _efl_canvas_wl_efl_gfx_entity_position_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_scale_set, _efl_canvas_wl_efl_gfx_entity_scale_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_scale_get, _efl_canvas_wl_efl_gfx_entity_scale_get),
      EFL_CANVAS_WL_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"aspect_propagate", __eolian_efl_canvas_wl_aspect_propagate_set_reflect, __eolian_efl_canvas_wl_aspect_propagate_get_reflect},
      {"minmax_propagate", __eolian_efl_canvas_wl_minmax_propagate_set_reflect, __eolian_efl_canvas_wl_minmax_propagate_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_wl_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Wl",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Comp),
   _efl_canvas_wl_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_wl_class_get, &_efl_canvas_wl_class_desc, EFL_CANVAS_GROUP_CLASS, NULL);
